%% Import data from text file.
% Script for importing data from the following text file:
%
%    D:\sydney 2019\data\2019_11_06-13_46_19p6_W_1p5000_ak_0p0154_aa_0p25_T0_0p6667\2019_11_06-13_46_19p6_W_1p5000_ak_0p0154_aa_0p25_T0_0p6667_pos.txt
%
% To extend the code to different selected data or a different text file,
% generate a function instead of a script.

% Auto-generated by MATLAB on 2019/11/06 15:39:49

%% Initialize variables.
filename = 'D:\sydney 2019\data\2019_11_06-13_46_19p6_W_1p5000_ak_0p0154_aa_0p25_T0_0p6667\2019_11_06-13_46_19p6_W_1p5000_ak_0p0154_aa_0p25_T0_0p6667_pos.txt';
delimiter = '\t';
startRow = 3;

%% Read columns of data as text:
% For more information, see the TEXTSCAN documentation.
formatSpec = '%s%s%s%s%s%s%[^\n\r]';

%% Open the text file.
fileID = fopen(filename,'r');

%% Read columns of data according to the format.
% This call is based on the structure of the file used to generate this
% code. If an error occurs for a different file, try regenerating the code
% from the Import Tool.
dataArray = textscan(fileID, formatSpec, 'Delimiter', delimiter, 'TextType', 'string', 'HeaderLines' ,startRow-1, 'ReturnOnError', false, 'EndOfLine', '\r\n');

%% Close the text file.
fclose(fileID);

%% Convert the contents of columns containing numeric text to numbers.
% Replace non-numeric text with NaN.
raw = repmat({''},length(dataArray{1}),length(dataArray)-1);
for col=1:length(dataArray)-1
    raw(1:length(dataArray{col}),col) = mat2cell(dataArray{col}, ones(length(dataArray{col}), 1));
end
numericData = NaN(size(dataArray{1},1),size(dataArray,2));

% Converts text in the input cell array to numbers. Replaced non-numeric
% text with NaN.
rawData = dataArray{1};
for row=1:size(rawData, 1)
    % Create a regular expression to detect and remove non-numeric prefixes and
    % suffixes.
    regexstr = '(?<prefix>.*?)(?<numbers>([-]*(\d+[\,]*)+[\.]{0,1}\d*[eEdD]{0,1}[-+]*\d*[i]{0,1})|([-]*(\d+[\,]*)*[\.]{1,1}\d+[eEdD]{0,1}[-+]*\d*[i]{0,1}))(?<suffix>.*)';
    try
        result = regexp(rawData(row), regexstr, 'names');
        numbers = result.numbers;
        
        % Detected commas in non-thousand locations.
        invalidThousandsSeparator = false;
        if numbers.contains(',')
            thousandsRegExp = '^\d+?(\,\d{3})*\.{0,1}\d*$';
            if isempty(regexp(numbers, thousandsRegExp, 'once'))
                numbers = NaN;
                invalidThousandsSeparator = true;
            end
        end
        % Convert numeric text to numbers.
        if ~invalidThousandsSeparator
            numbers = textscan(char(strrep(numbers, ',', '')), '%f');
            numericData(row, 1) = numbers{1};
            raw{row, 1} = numbers{1};
        end
    catch
        raw{row, 1} = rawData{row};
    end
end


%% Split data into numeric and string columns.
rawNumericColumns = raw(:, 1);
rawStringColumns = string(raw(:, [2,3,4,5,6]));


%% Replace non-numeric cells with NaN
R = cellfun(@(x) ~isnumeric(x) && ~islogical(x),rawNumericColumns); % Find non-numeric cells
rawNumericColumns(R) = {NaN}; % Replace non-numeric cells

%% Create output variable
p6W1p5000ak0p0154aa0p25T00p6667pos = table;
p6W1p5000ak0p0154aa0p25T00p6667pos.gauges_position = cell2mat(rawNumericColumns(:, 1));
p6W1p5000ak0p0154aa0p25T00p6667pos.depth = rawStringColumns(:, 1);
p6W1p5000ak0p0154aa0p25T00p6667pos.VarName3 = rawStringColumns(:, 2);
p6W1p5000ak0p0154aa0p25T00p6667pos.VarName4 = rawStringColumns(:, 3);
p6W1p5000ak0p0154aa0p25T00p6667pos.VarName5 = rawStringColumns(:, 4);
p6W1p5000ak0p0154aa0p25T00p6667pos.VarName6 = rawStringColumns(:, 5);

%% Clear temporary variables
clearvars filename delimiter startRow formatSpec fileID dataArray ans raw col numericData rawData row regexstr result numbers invalidThousandsSeparator thousandsRegExp rawNumericColumns rawStringColumns R;